
#ifndef MATRIX_H
#define MATRIX_H 1

typedef unsigned char byte;

typedef struct {
	int element_size;
	int type;
	int rows;
	int cols;
	void **ptr;
} MATRIX;

typedef struct {
	byte R, G, B;
} RGB;

/**
    type = 0   1 bit/pixel, 0 is write
    type = 1   1 bit/pixel, 1 is write
    type = 2   4 bits/pixel, 16 grey tones
    type = 3   4 bits/pixel, palette 16 colors
    type = 4   8 bits/pixel, palette 256 colors
    type = 5   8 bits/pixel, 256 grey tones
    type = 6   24 bits/pixel, RGB
    type = 7   16 bits/pixel, short integers matrix
    type = 8   32 bits/pixel, integers matrix
    type = 9   32 bits/pixel, floats matrix
    type = 10  64 bits/pixel, doubles matrix
    *
    *
    *
    *
    *
    PBM	RAWBITS is eight pixels per byte
	PGM	RAWBITS is one pixel per byte
	PPM	RAWBITS is three bytes per pixel

**/
#define pixels2bytes(n)     (((n)+7)/8)
#define grayvalue(r,g,b)  (((r*30)/100) + ((g*59)/100) + ((b*11)/100))

void strmfe ( char *nuevo, char * old, char * ext);
MATRIX *matrix_allocate (unsigned int rows,unsigned int cols, int size );
void matrix_free(MATRIX *);
int comparaRGB(RGB color1, RGB color2);


#endif
